package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.Projectile;
import net.minecraft.world.item.ItemStack;

public class PsychicAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.PsychicAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.PsychicAffix::new));
  }
  
  public PsychicAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(100.0F * getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 0.0F)) });
    MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 1.0F)) });
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat == LootCategory.SHIELD && this.values.containsKey(rarity));
  }
  
  public float onShieldBlock(ItemStack stack, LootRarity rarity, float level, LivingEntity entity, DamageSource source, float amount) {
    Entity entity1 = source.m_7640_();
    if (entity1 instanceof Projectile) {
      Projectile arrow = (Projectile)entity1;
      Entity owner = arrow.m_19749_();
      if (owner instanceof LivingEntity) {
        LivingEntity living = (LivingEntity)owner;
        living.m_6469_(entity.m_269291_().m_269298_(Apoth.DamageTypes.PSYCHIC, (Entity)entity), amount * getTrueLevel(rarity, level));
      } 
    } 
    return super.onShieldBlock(stack, rarity, level, entity, source, amount);
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
